"""First Commit

Revision ID: aac186760633
Revises:
Create Date: 2021-11-03 15:07:47.248330

"""
from alembic import op
import sqlalchemy as sa
from sqlalchemy.dialects import postgresql

# revision identifiers, used by Alembic.
revision = "aac186760633"
down_revision = None
branch_labels = None
depends_on = None

filestatusenum = sa.Enum("NOT_UPLOADED", "AVAILABLE", "ERROR", name="filestatusenum")
filetypeenum = sa.Enum("PARAM", "CONF", name="filetypeenum")
ionchargeenum = sa.Enum("POSITIVE", "NEGATIVE", name="ionchargeenum")


def upgrade() -> None:
    # ### commands auto generated by Alembic - please adjust! ###
    op.create_table(
        "fragfile",
        sa.Column("id", postgresql.UUID(as_uuid=True), nullable=False),
        sa.Column(
            "file_status",
            filestatusenum,
            nullable=False,
        ),
        sa.Column("file_type", filetypeenum, nullable=False),
        sa.Column(
            "ion_charge",
            ionchargeenum,
            nullable=False,
        ),
        sa.Column(
            "file_metadata", postgresql.JSONB(astext_type=sa.Text()), nullable=True
        ),
        sa.Column("file_hash", sa.String(), nullable=True),
        sa.PrimaryKeyConstraint("id"),
    )
    op.create_index(
        op.f("ix_fragfile_file_status"), "fragfile", ["file_status"], unique=False
    )
    op.create_index(
        op.f("ix_fragfile_file_type"), "fragfile", ["file_type"], unique=False
    )
    op.create_index(op.f("ix_fragfile_id"), "fragfile", ["id"], unique=False)
    op.create_index(
        op.f("ix_fragfile_ion_charge"), "fragfile", ["ion_charge"], unique=False
    )
    # ### end Alembic commands ###


def downgrade() -> None:
    # ### commands auto generated by Alembic - please adjust! ###
    op.drop_index(op.f("ix_fragfile_ion_charge"), table_name="fragfile")
    op.drop_index(op.f("ix_fragfile_id"), table_name="fragfile")
    op.drop_index(op.f("ix_fragfile_file_type"), table_name="fragfile")
    op.drop_index(op.f("ix_fragfile_file_status"), table_name="fragfile")
    op.drop_table("fragfile")

    filestatusenum.drop(op.get_bind(), checkfirst=False)
    filetypeenum.drop(op.get_bind(), checkfirst=False)
    ionchargeenum.drop(op.get_bind(), checkfirst=False)
    # ### end Alembic commands ###
